Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 380057)
+++ channels/chan_skinny.c	(working copy)
@@ -7016,13 +7016,19 @@
 		}
 		*bufaddr = htolel(dlen);
 
-		res = read(s->fd, s->inbuf+4, dlen+4);
-		ast_mutex_unlock(&s->lock);
-		if (res < 0) {
-			ast_log(LOG_WARNING, "read() returned error: %s\n", strerror(errno));
-			return res;
-		} else if (res != (dlen+4)) {
-			ast_log(LOG_WARNING, "Skinny Client sent less data than expected.\n");
+		res = 0;
+		do {
+			int bytesread = res;
+			res = read(s->fd, s->inbuf+4+bytesread, dlen+4);
+			if (res < 0) {
+				ast_log(LOG_WARNING, "read() returned error: %s\n", strerror(errno));
+				return res;
+			}
+			res += bytesread;
+		} while (res < (dlen + 4));
+
+		if (res != (dlen+4)) {
+			ast_log(LOG_WARNING, "Skinny Client sent more data than expected.\n");
 			return -1;
 		}
 		return res;
